/*
    AutoX11, a tool to automate tasks in an X11 environment
    Copyright (C) 2014  Alicia <alicia@ion.nu>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <X11/extensions/XTest.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "autox11.h"

void findneedle(XImage* haystack, GdkPixbuf* needle, void callback(int,int))
{
  unsigned char* gdkpixels=gdk_pixbuf_get_pixels(needle);
  int gdkbpp=gdk_pixbuf_get_bits_per_sample(needle)*gdk_pixbuf_get_n_channels(needle)/8;
  int xbpp=haystack->bits_per_pixel/8;
  int hy;
  for(hy=0; hy<haystack->height-gdk_pixbuf_get_height(needle); ++hy)
  {
    int hx;
    for(hx=0; hx<haystack->width-gdk_pixbuf_get_width(needle); ++hx)
    {
      int ny, nx;
      for(ny=0; ny<gdk_pixbuf_get_height(needle); ++ny)
      {
        for(nx=0; nx<gdk_pixbuf_get_width(needle); ++nx)
        {
          if(gdk_r(needle, nx, ny)!=x_r(haystack, hx+nx, hy+ny) ||
             gdk_g(needle, nx, ny)!=x_g(haystack, hx+nx, hy+ny) ||
             gdk_b(needle, nx, ny)!=x_b(haystack, hx+nx, hy+ny)){nx=0; break;}
        }
        if(!nx){ny=0; break;}
      }
      if(ny) // Hackily reuse ny as an indicator of success
      {
        callback(hx, hy);
//      printf("Found match at %ix%i\n", xpos/3, hy);
      }
    }
  }
}
